#ifndef __VHEX_DISPLAY__
# define __VHEX_DISPLAY__

//TODO: plate-form specific
enum {
	/* Compatibility with fx9860g color names */
	C_WHITE = 0xffff,
	C_LIGHT = 0xad55,
	C_DARK  = 0x528a,
	C_BLACK = 0x0000,

	/* Other colors */
	C_RED   = 0xf800,
	C_GREEN = 0x07e0,
	C_BLUE  = 0x001f,

	C_NONE = -1,
	C_INVERT = -2,
};


/* Alignment settings for dtext_opt() and dprint_opt(). Combining a vertical
   and a horizontal alignment option specifies where a given point (x,y) should
   be relative to the rendered string. */
enum {
	/* Horizontal settings: default in dtext() is DTEXT_LEFT */
	DTEXT_LEFT   = 0,
	DTEXT_CENTER = 1,
	DTEXT_RIGHT  = 2,
	/* Vertical settings: default in dtext() is DTEXT_TOP */
	DTEXT_TOP    = 0,
	DTEXT_MIDDLE = 1,
	DTEXT_BOTTOM = 2,
};


/* dtext_opt(): Display a string of text */
extern void dtext_opt(
	int x, int y,
	int fg, int bg,
	int halign, int valign,
	char const *str, int size
);

/* dpixel(): Change a pixel's color */
extern void dpixel(int x, int y, int color);

/* dupdate(): Push the video RAM to the display driver */
extern void dupdate(void);

/* dclear(): Fill the screen with a single color */
extern void dclear(int color);

/* dascii() : display one ASCII character */
extern void dascii(int x, int y, int fg, int bg, int n);

/* dline(): Render a straight line */
extern void dline(int x1, int y1, int x2, int y2, int color);

/* dtext() : display raw text */
extern void dtext(int x, int y, int fg, char const * restrict const text);

/* dprint() : display formated text */
extern void dprint(int x, int y, int fg, char const * const text, ...);

/* dsize(): Get the width and height of rendered text */
extern void dsize(char const *str, int *w, int *h);

/* dnsize(): Get the width and height of rendered text for the n first char */
extern void dnsize(char const *str, int n, int *w, int *h);

/* drect(): Fill a rectangle of the screen */
extern void drect(int x1, int y1, int x2, int y2, int color);

/* dhline(): Draw horizontal line */
extern void dhline(int x1, int x2, int y, int color);

/* dvline(): Draw vertical line */
extern void dvline(int y1, int y2, int x, int color);

#endif /*__VHEX_DISPLAY__*/
